Name:           spice-vdagent
Version:        0.12.0
Release:        4%{?dist}
Summary:        Agent for Spice guests
Group:          Applications/System
License:        GPLv3+
URL:            http://spice-space.org/
Source0:        http://spice-space.org/download/releases/%{name}-%{version}.tar.bz2
Patch1:         0001-x11-randr-Fix-setting-of-mode-on-non-arbitrary-resol.patch
Patch2:         0002-Fix-running-on-a-vm-with-multiple-qxl-devs-without-X.patch
Patch3:         0003-Add-a-proper-copyright-header-to-src-vdagent-x11-ran.patch
Patch4:         0004-make-a-few-functions-static.patch
Patch5:         0005-randr-do-not-set-crtc-mode-to-NULL-when-changing-res.patch
Patch6:         0006-vdagentd-send-monitors-config-to-currently-active-ag.patch
Patch7:         0007-randr-Add-some-more-debugging-messages.patch
Patch8:         0008-randr-Round-x-monitor-coordinates-to-a-multiple-of-8.patch
Patch9:         0009-randr-Move-same_monitor_configs-call-to-after-zero-r.patch
Patch10:        0010-randr-Call-update_randr_res-from-same_monitor_config.patch
Patch11:        0011-randr-Also-compare-screen-width-height-in-same_monit.patch
Patch12:        0012-randr-Properly-update-things-if-the-number-of-monito.patch
Patch13:        0013-randr-Use-XRRGetScreenResourcesCurrent-rhbz-888821.patch
Patch14:        0014-randr-Properly-delete-old-mode-in-multi-monitor-conf.patch
Patch15:        0015-randr-Limit-searching-mode-by-size-to-the-current-ou.patch
Patch16:        0016-vdagent-x11-randr-Fix-building-warning.patch
Patch17:        0017-vdagentd-Fix-building-warning.patch
Patch18:        0018-randr-Make-all-sizes-and-coordinates-signed.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires:  spice-protocol libpciaccess-devel dbus-devel
BuildRequires:  libXrandr-devel libXinerama-devel libXfixes-devel libtool
BuildRequires:  desktop-file-utils
ExclusiveArch:  i686 x86_64
Requires:       ConsoleKit
Requires(post):   chkconfig
Requires(postun): initscripts
Requires(preun):  chkconfig
Requires(preun):  initscripts

%description
Spice agent for Linux guests offering the following features:

Features:
* Client mouse mode (no need to grab mouse by client, no mouse lag)
  this is handled by the daemon by feeding mouse events into the kernel
  via uinput. This will only work if the active X-session is running a
  spice-vdagent process so that its resolution can be determined.
* Automatic adjustment of the X-session resolution to the client resolution
* Support of copy and paste (text and images) between the active X-session
  and the client


%prep
%setup -q
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch13 -p1
%patch14 -p1
%patch15 -p1
%patch16 -p1
%patch17 -p1
%patch18 -p1
# Stop trying to regenerate configure because of the patches (not needed)
touch -r README configure.ac
cp -a data/rsyslog.d/spice-vdagentd.conf rsyslog.conf


%build
%configure
make %{?_smp_mflags}


%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT
# RHEL-6 has no /etc/rsyslog.d
rm $RPM_BUILD_ROOT%{_sysconfdir}/rsyslog.d/spice-vdagentd.conf


%clean
rm -rf $RPM_BUILD_ROOT


%post
/sbin/chkconfig --add spice-vdagentd
if ! grep -q spice-vdagent /etc/rsyslog.conf; then
  echo >> /etc/rsyslog.conf
  cat %{_datadir}/doc/%{name}-%{version}/rsyslog.conf >> /etc/rsyslog.conf
fi

%preun
if [ $1 = 0 ] ; then
    /sbin/service spice-vdagentd stop >/dev/null 2>&1
    /sbin/chkconfig --del spice-vdagentd
fi

%postun
if [ "$1" -ge "1" ] ; then
    /sbin/service spice-vdagentd condrestart >/dev/null 2>&1 || :
fi


%files
%defattr(-,root,root,-)
%doc COPYING ChangeLog README TODO rsyslog.conf
%{_initddir}/spice-vdagentd
%{_bindir}/spice-vdagent
%{_sbindir}/spice-vdagentd
%{_var}/run/spice-vdagentd
%{_sysconfdir}/xdg/autostart/spice-vdagent.desktop
# For /usr/share/gdm/autostart/LoginWindow/spice-vdagent.desktop
# We own the dir too, otherwise we must Require gdm
%{_datadir}/gdm


%changelog
* Tue Jan  8 2013 Hans de Goede <hdegoede@redhat.com> - 0.12.0-4
- Fix various issues with dynamic resolution and monitor support
  Resolves: rhbz#888821

* Mon Nov 26 2012 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.12.0-3
- Fix crash when first resizing monitor
  Resolves: rhbz#872633

* Sun Oct 14 2012 Hans de Goede <hdegoede@redhat.com> - 0.12.0-2
- Fix wrong mouse coordinates on vms with multiple qxl devices
  Resolves: rhbz#855110

* Sat Sep  1 2012 Hans de Goede <hdegoede@redhat.com> - 0.12.0-1
- New upstream release 0.12.0
  Resolves: rhbz#842355
- This switches to syslog for logging, adding timestamps, etc. to the logs
  Resolves: rhbz#747894
- This adds support for dynamically adding monitors and resolutions
  Resolves: rhbz#842298

* Fri Oct 28 2011 Hans de Goede <hdegoede@redhat.com> 0.8.1-3
- Fix resolution sync not working when connecting with a multi monitor client
  to a single monitor guest
  Resolves: rhbz#748760

* Mon Oct  3 2011 Hans de Goede <hdegoede@redhat.com> 0.8.1-2
- Add support for multiple monitors / Xinerama setups
  Resolves: rhbz#740851

* Mon Jul 18 2011 Hans de Goede <hdegoede@redhat.com> 0.8.1-1
- New upstream release 0.8.1
  Resolves: rhbz#722477
- Fixes vdagent not auto restarting when vdagentd gets restarted
  Resolves: rhbz#681797
- Fixes vdagent crash when copying large (multiple megabytes) amount of data
  from the client clipboard to the guest clipboard
  Resolves: rhbz#690164

* Thu Mar 24 2011 Hans de Goede <hdegoede@redhat.com> 0.6.3-8
- Fix chunk demultiplexing when chunks from messages for different ports
  get intermixed
  Related: rhbz#658464

* Thu Mar 17 2011 Hans de Goede <hdegoede@redhat.com> 0.6.3-7
- Daemonize per user session vdagent process on startup, this avoids a long
  delay after logging in
- Fix mouse not working with the agent installed
  Resolves: rhbz#688257

* Mon Mar 07 2011 Hans de Goede <hdegoede@redhat.com> 0.6.3-6
- Fix setting of the guest resolution from a multi monitor client
  Resolves: rhbz#680227
- Limit build archs to i686 and x86_64
  Related: rhbz#658464

* Mon Jan 10 2011 Hans de Goede <hdegoede@redhat.com> 0.6.3-5
- Make sysvinit script exit cleanly when not running on a spice enabled vm
  Related: rhbz#658464

* Tue Dec 14 2010 Hans de Goede <hdegoede@redhat.com> 0.6.3-4
- Build for RHEL-6
  Resolves: rhbz#658464

* Fri Nov 19 2010 Hans de Goede <hdegoede@redhat.com> 0.6.3-3
- Put the pid and log files into their own subdir (#648553)

* Mon Nov  8 2010 Hans de Goede <hdegoede@redhat.com> 0.6.3-2
- Fix broken multiline description in initscript lsb header (#648549)

* Sat Oct 30 2010 Hans de Goede <hdegoede@redhat.com> 0.6.3-1
- Initial Fedora package
